package enumerations;

/**
 * A simple 3-state system model:
 * <ul> 
 * <li> {@link #DOWN} </li>
 * <li> {@link #STAY} </li> 
 * <li> {@link #UP} </li> 
 * </ul>
 * This is used in the {@link interfaces.ElevatorSpecification}
 * @author J Paul Gibson
 */
public enum DirectionState {
	/**
	 * When the elevator is descending
	 */
	DOWN, 
	
	/**
	 * When the elevator is at rest at a floor
	 */
	STAY,
	
	/**
	 * When the elevator is ascending
	 */
	UP

}
