package factoriesSPL;

import models.elevators.ElevatorWithDoors;
import models.elevators.ElevatorWithDoorsAndLockableFloors;
import models.elevators.ElevatorWithLockableFloors;
import interfaces.ElevatorSpecification;
import views.JPanel_ElevatorSpecification;
import views.JPanel_ElevatorWithDoors;
import views.JPanel_ElevatorWithDoorsAndLockableFloors;
import views.JPanel_ElevatorWithLockableFloors;


public class JPanel_Elevator_Factory {
	
	
	public static JPanel_ElevatorSpecification makeJPanel_Elevator (ElevatorSpecification elevator, int animationTime) {

		
		if (elevator instanceof ElevatorWithDoorsAndLockableFloors)
			return new JPanel_ElevatorWithDoorsAndLockableFloors( (ElevatorWithDoorsAndLockableFloors) elevator, animationTime);
		
		if (elevator instanceof ElevatorWithLockableFloors)
			return new JPanel_ElevatorWithLockableFloors( (ElevatorWithLockableFloors) elevator, animationTime);
		
		else	if (elevator instanceof ElevatorWithDoors)
				return new JPanel_ElevatorWithDoors( (ElevatorWithDoors) elevator, animationTime);
		
		else 
				return new JPanel_ElevatorSpecification(elevator, animationTime);
						
					
			
		}

}
