package unit_tests.elevatorUsers;


import models.elevatorUsers.IntelligentElevatorUserWithKey;

import org.junit.Assert;
import org.junit.Test;

import enumerations.DirectionState;
import enumerations.UserState;

/**
 * TODO add specific tests for unlocking locked floors
 * @author jpaulgibson
 *
 */
public class JUnit_IntelligentElevatorUserWithKey extends JUnit_IntelligentElevatorUser{
	
	@Override
	public   void setUp() {
		
		elevatorUserUnderTest = new IntelligentElevatorUserWithKey(USER_FROM_FLOOR, USER_TO_FLOOR, elevator);
		
		Assert.assertTrue(elevatorUserUnderTest.invariant());
	}
	
	@Override
	@Test
	public  void test_toString(){
		Assert.assertEquals("IntelligentElevatorUserWithKey "+elevatorUserUnderTest.hashCode()+" - from: "
				+ USER_FROM_FLOOR +" to: "+ USER_TO_FLOOR+ " currently ARRIVED_AT_FLOOR",
	            elevatorUserUnderTest.toString());
		
		Assert.assertTrue(elevatorUserUnderTest.invariant());
	}
	
	@Override
	public void test_makeDecision() {
		
		Assert.assertFalse(elevator.upPressedAtFloor(USER_FROM_FLOOR ));
		Assert.assertFalse(elevator.downPressedAtFloor(USER_FROM_FLOOR));
		Assert.assertNotEquals(elevator.currentFloor(), USER_FROM_FLOOR);
		Assert.assertEquals(0, elevator.currentFloor());
		Assert.assertEquals(UserState.ARRIVED_AT_FLOOR, elevatorUserUnderTest.get_state());
		
		elevatorUserUnderTest.makeDecision();
		
		System.out.println(elevator);
		System.out.println(elevatorUserUnderTest);
		
		Assert.assertTrue(elevator.upPressedAtFloor(USER_FROM_FLOOR ));
		Assert.assertFalse(elevator.downPressedAtFloor(USER_FROM_FLOOR));
		Assert.assertNotEquals(elevator.currentFloor(), USER_FROM_FLOOR);
		Assert.assertEquals(0, elevator.currentFloor());
		Assert.assertEquals(UserState.WAITING_AT_FLOOR, elevatorUserUnderTest.get_state());
		
		elevatorUserUnderTest.makeDecision();
		
		Assert.assertNotEquals(elevator.currentFloor(), USER_FROM_FLOOR);
		Assert.assertTrue(elevator.upPressedAtFloor(USER_FROM_FLOOR));
		Assert.assertFalse(elevator.downPressedAtFloor(USER_FROM_FLOOR)); 
			
		elevator.updateFloor(); elevatorUserUnderTest.makeDecision();
		
		
		
		Assert.assertTrue(elevator.upPressedAtFloor(USER_FROM_FLOOR));
		Assert.assertFalse(elevator.downPressedAtFloor(USER_FROM_FLOOR));
		Assert.assertEquals(0, elevator.currentFloor());
		Assert.assertEquals(DirectionState.UP, elevator.currentDirection());
		
		elevator.updateFloor();
	    elevatorUserUnderTest.makeDecision();
	    
		Assert.assertEquals(elevator.currentFloor(), USER_FROM_FLOOR);
		Assert.assertFalse(elevator.upPressedAtFloor(USER_FROM_FLOOR));
		Assert.assertFalse(elevator.downPressedAtFloor(USER_FROM_FLOOR));
		for (int floor = 0; floor < elevator.topFloor(); floor++){
			
			if (floor == USER_TO_FLOOR) Assert.assertTrue(elevator.floorPressedInElevator(floor));
			                       else Assert.assertFalse(elevator.floorPressedInElevator(floor));
		}
		
		Assert.assertEquals(UserState.IN_ELEVATOR, elevatorUserUnderTest.get_state());
		
		elevator.updateFloor();
		elevatorUserUnderTest.makeDecision();
		Assert.assertFalse(elevator.upPressedAtFloor(USER_FROM_FLOOR));
		Assert.assertFalse(elevator.downPressedAtFloor(USER_FROM_FLOOR));
		Assert.assertFalse(elevator.floorPressedInElevator(USER_TO_FLOOR));
		Assert.assertEquals(UserState.SERVICED, elevatorUserUnderTest.get_state());
		Assert.assertFalse(elevator.upPressedAtFloor(USER_TO_FLOOR));
		Assert.assertFalse(elevator.downPressedAtFloor(USER_TO_FLOOR));
		
	}


}
