package unit_tests.elevators;

import org.junit.Assert;
import org.junit.Test;

import enumerations.DirectionState;
import models.elevatorLogicUnit.StupidLogicUnit;
import models.elevators.Elevator;
import unit_tests.elevators.unitTestAbstractions_elevators.JUnit_ElevatorSpecification;
import validation_tests.use_case10.Validation_Elevator_UseCase10;

public  class JUnit_Elevator_Stupid  extends JUnit_ElevatorSpecification{

	@Override
	public void setUp() throws Exception {
		        
		        // Make a stupid controller, not yet bound to (installed in) a particular elevator
				StupidLogicUnit controller = new StupidLogicUnit(null);
				
				//Make an elevator without doors, not yet bound to a particular controller
				elevatorUnderTest = new Elevator(Validation_Elevator_UseCase10.MINIMUM_NUMBER_OF_FLOORS);

				// Install the controller to be tested in the elevator
				elevatorUnderTest.installLogicUnit(controller);
		
	}
	
	
	/**
	 * The use case scenario 1 :
	 *   Elevator State expected after running scenario:
          DirectionState = DOWN
          Floor = 2
          Number of floors = 5
          Requested Floors Inside Elevator:
          DirectionState Requests For Elevator At Floor: 0- 1- 2- 3- 4-
          Controller type = Stupid Controller

	 */
	@Test
	public void test_useCaseScenario1(){
		
        Validation_Elevator_UseCase10.validate(elevatorUnderTest);
		
		Assert.assertEquals(elevatorUnderTest.currentDirection(), DirectionState.DOWN);
		Assert.assertEquals(elevatorUnderTest.currentFloor(), 2);
		
		for (int floor =0; floor< Validation_Elevator_UseCase10.MINIMUM_NUMBER_OF_FLOORS; floor++){
		   Assert.assertFalse(elevatorUnderTest.floorPressedInElevator(floor));
		   Assert.assertFalse(elevatorUnderTest.downPressedAtFloor(floor));
		   Assert.assertFalse(elevatorUnderTest.upPressedAtFloor(floor));
		}
	
	}

}
