package views;

import java.awt.BorderLayout;
import java.awt.Container;

import factoriesSPL.JPanel_Elevator_Factory;
import interfaces.ElevatorSpecification;

import javax.swing.JFrame;

@SuppressWarnings("serial")
public class JFrame_ElevatorSpecification extends JFrame{
	
	JPanel_ElevatorSpecification elevatorJPanel;
	
	
	public JFrame_ElevatorSpecification (ElevatorSpecification elevator, String frameName, int location_x, int location_y, int animationTime){
		
		super(frameName);
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

	    setLocation(location_x, location_y);
        setResizable(false);
		Container contentPane = getContentPane();
		elevatorJPanel = (JPanel_ElevatorSpecification) JPanel_Elevator_Factory.makeJPanel_Elevator(elevator, animationTime);
		contentPane.add(elevatorJPanel, BorderLayout.CENTER );
		pack();
		setVisible(true);	
	}
	
	public void startPanelAnimation(){
		elevatorJPanel.start_animation();
		
	}
	
	public void stopPanelAnimation(){
		elevatorJPanel.stop_animation();
		
	}


}
