package views;

import java.awt.Color;

/**
 * The colours used in the graphical animation of the elevator
 * @author jpaulgibson
 *
 */
public class JPanel_ColourConfiguration {
	
	final static Color BACKGROUND_COLOUR = Color.lightGray;
	
	final static Color BUTTON_BACKGROUND_CHANGING_COLOUR = Color.orange;
	final static Color BUTTON_BACKGROUND_OFF_COLOUR = Color.gray;
	final static Color BUTTON_BACKGROUND_ON_COLOUR = Color.yellow;
	final static Color BUTTON_TEXT_ON_COLOUR = Color.GREEN;
	final static Color BUTTON_TEXT_OFF_COLOUR = Color.black;

	final static Color ELEVATOR_COLOUR = Color.cyan;
	final static Color ELEVATOR_TEXT_COLOUR = Color.black;
	
	final static Color FLOOR_COLOUR = Color.blue;
	
	/**
	 * Only relevant for {@link interfaces.ElevatorWithDoorsSpecification} and subclasses
	 */
	final static Color DOOR_OPEN_COLOUR = BACKGROUND_COLOUR;
	
	/**
	 * Only relevant for {@link interfaces.ElevatorWithDoorsSpecification} and subclasses
	 */
	final static Color DOOR_CLOSED_COLOUR = Color.red;
	
	
	/**
	 * Only relevant for {@link interfaces.ElevatorWithLockableFloorsSpecification} and subclasses
	 */
	final static Color LOCKED_FLOOR_COLOR = Color.RED;
	
	/**
	 * Only relevant for {@link interfaces.ElevatorWithLockableFloorsSpecification} and subclasses
	 */
	final static Color UNLOCKED_FLOOR_COLOR = Color.BLACK;
	

}
